#include "base.as"
#include "races.as"

bool pitstop_drivingTooFast = false;
racesManager races();

void createRaces()
{
	//races.showCheckPointInfoWhenNotInRace = true;
	// Add a RaceFinish callback
    races.setCallback("RaceFinish", on_raceFinish);  
	
	double[][] race_tuanga1 = 
		{
			{2079.5,  216.88, 3683.8, 0,  -90.4, 0},
			{2009.0,  173.55, 3866.4, 0,   83.6, 0},
			{1858.4,  186.11, 3468.1, 0,   94.9, 0},
			{ 517.2,  355.96, 2673.0, 0, -134.0, 0},
			{3473.0,  366.51, 2334.2, 0,   50.2, 0},
			{3283.5,  494.37,  988.1, 0,  173.7, 0},
			{3208.5,  561.65,  918.2, 0,  157.0, 0},
			{2581.6,  847.84, 3346.5, 0,   48.1, 0},
			{2466.6, 1002.13, 1542.9, 0,  143.9, 0},
			{1451.0, 1133.36, 1882.1, 0,  159.3, 0},
			{1681.2, 1356.67, 2805.8, 0,   51.2, 0},
			{1880.6, 1426.63, 1782.4, 0,  147.0, 0},
			{1768.9, 1530.65, 2075.9, 0,  -74.6, 0},
			{1997.4, 1684.14, 2122.2, 0, -178.2, 0},
			{2144.7, 1738.62, 2713.4, 0,  -49.3, 0},
			{2143.6, 1921.06, 2540.4, 0,  -63.0, 0},
			{2156.7, 1990.72, 2382.5, 0, -171.2, 0}			
		};
	//                              race name    coordinates   #laps         checkpoint object     startline object        finishline object       race version
	int raceID = races.addRace("Tuanga Challenge To the top!", race_tuanga1, races.LAPS_NoLaps, "chp-checkpoint", "chp-start", "chp-start", "unknown_author-1.0");

	races.setVersion(raceID, "unknown_author-1.0");
	races.finalize(raceID);
	/*
	// add a cancel point for all races (we can do this for all races by setting the race ID to -1)
	double[][] cancelpoint = {{965, 8.8, 580, 0, 90, 0,}};
	races.addCancelPoint(-1, "31-trigger10x10", cancelpoint[0], on_cancelPoint);
	*/
}

// The default RoR main function
void main()
{
	createRaces();
	//races.submitScore(false);
	// add the pitstop event
	//game.spawnObject("trucktrigger", "pitstop", vector3(883.356262f, 0.340250f, 1302.838745f), vector3(0.000010f, 0.000000f, 0.000000f), "PitStopEvent", false);	
}

// The default RoR event callback
void eventCallback(int eventnum, int value)
{
	// required for the races!
	races.eventCallback(eventnum, value);
}

// the event callback for our cancelpoint
void on_cancelPoint(dictionary@ info)
{
	game.flashMessage("Race aborted.", 4, -1);
}

// The event callback for finishing a race
void on_raceFinish(dictionary@ info)
{
    // Get the race ID
    int raceID;
    info.get("raceID", raceID);
    
    // get the lap time (in seconds)
    float lapTime = game.getTime() - races.lapStartTime;
    
    // get the race time (in seconds)
    float raceTime = game.getTime() - races.raceStartTime;

}  